"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = void 0;
const graphql_1 = require("graphql");
const utils_1 = require("./utils");
const plugin = (schema) => {
    const typeMap = schema.getTypeMap();
    const allTypeNames = Object.keys(typeMap);
    const getTypeNames = allTypeNames.filter((typeName) => {
        const type = typeMap[typeName];
        return (!(0, graphql_1.isScalarType)(type) &&
            !(0, utils_1.isBuiltInScalar)(typeName) &&
            !(0, utils_1.isDoubleUnderline)(typeName));
    });
    const unionTypeName = getTypeNames
        .map((typeName) => `'${typeName}'`)
        .join(" | ");
    const result = getTypeNames
        .map((typeName) => {
        console.log({ typeName });
        return `export const is${typeName} = (field: { __typename?: ${unionTypeName}; }): field is ${typeName} => field.__typename === '${typeName}';`;
    })
        .filter(Boolean)
        .join("\n");
    return result;
};
exports.plugin = plugin;
